;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, Bruce D. Lightner and
; Lightner Engineering.  Use subject to licensing restrictions described
; the file LICENSE.txt.  If you do not agree with the licensing terms then
; you must return and/or destroy this software immediately!
;-------------------------------------------------------------------------

.data

.global cmdop1
bss cmdop1,2                       ; command optional arguement #1 (word)
.global cmdop2
bss cmdop2,2                       ; command optional arguement #2 (word)
.global cmd_ok
bss cmd_ok,1                       ; used by command processor
.text

;+
; **-command_check-check for command from serial port.
;-
    .global do_prompt
do_prompt:
    outstr "\r\n# "
no_command:
    ret

    .global import_cli_exec
    .global cli_exec
import_cli_exec:
cli_exec:
    clr r20                 ; default to bad command
    sts cmd_ok,r20

    rcall pcode
    pcall pfindcmd
    asm

    lds r20,cmd_ok          ; command OK?
    tst r20
    brne cli_exec_ok
    putchar '?'

cli_exec_ok:
    ret

;
; if no command, keep looping.
;
    .global command_check
command_check:
    lds     w,ready
    tst     w
    breq    no_command          ; none pending
;
; there is a command in the input buffer, nul-terminate it.
;
    ldsbw z,nch
    addwi z,inbuf
    clr     r17
    st      z,r17               ; nul-terminate
    sts ready,r17
    sts nch,r17                     ; mark buffer empty
;
; process command.
;
    crlf
    rcall cli_exec
    rjmp do_prompt

;
;   p-code command checker
;
;   r10 = 1- or 2-byte command code
;   r12 = AVR assembly routine to call if command codes match
;
    .global pchk_cmd
pchk_cmd:  pcode_routine 2
    movw r18,r10            ; move target command bytes to r18
    movwi x,inbuf           ; move input buffer pointer to x
    ld r16,x+               ; get first character of input command buffer
    cp r16,r18              ; match with command?
    brne chk_cmd_exit       ; no...exit
    cpi r19,0               ; yes...more command bytes?
    breq chk_cmd_1          ; no...execute command
    ld r16,x+               ; get second character of input command buffer
    cp r16,r19              ; match with command?
    brne chk_cmd_exit       ; no...exit
chk_cmd_1:
    sts cmd_ok,r18          ; show good command
    adiw xl,1
    rcall hexcvtw           ; get next hex word from command buffer
    sts cmdop1,i0           ; save as LSB of address
    sts cmdop1+1,i1         ; save as MSB of address

    adiw xl,1
    rcall hexcvtw           ; get next hex word from command buffer
    mov r20,i0              ; r20/21 = parameter #2
    mov r21,i1              ;
    sts cmdop2,i0           ; save as LSB of count/word
    sts cmdop2+1,i1         ; save as MSB of count/word

    ldsw y,cmdop1           ; y = parameter #1
    movw z,r12              ; call routine
    shrw z                  ; convert to word address
    pushw p                 ; save pcode PC...we may do pcode!
    icall                   ; call target command routine
    popw p
#if defined(PCODE_DEBUG)
    popw y
    putchar 'R'
    rcall hexy
    pushw y
#endif
chk_cmd_exit:
    ret

