;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, Bruce D. Lightner and
; Lightner Engineering.  Use subject to licensing restrictions described
; the file LICENSE.txt.  If you do not agree with the licensing terms then
; you must return and/or destroy this software immediately!
;-------------------------------------------------------------------------

#if !defined(HEXCVT_INCLUDED)
#define HEXCVT_INCLUDED

;+
; **-hexcvtb-hex convert byte.
;
; inputs:
;       x -> buffer
;
; outputs:
;       i0  = byte value
;       x   = x + 2
;-

.global hexcvtb

hexcvtb:
	push r16
	push i1

	clr i0                  ; default to zero
	ld r16,x+               ; get next byte
	rcall h2nib             ; convert it
	ld r16,x+               ; get next byte
	rcall h2nib

	pop i1
	pop r16
	ret

#if 1
;+
; **-hexcvtw-hex convert word.
;
; inputs:
;       x -> buffer
;
; outputs:
;       i0,i1  = word value
;       x      = point to next character < '0'
;-

.global hexcvtw

hexcvtw:
	push r16

	clr i0                  ; default to zero
	clr i1
h2w0:
	ld r16,x                ; get next nibble

	cpi r16,'0'
	brlt h2wx               ; <'0'...time to exit
	incw x                  ; bump x
	rcall h2nib             ; convert nibble in r16
	rjmp h2w0
h2wx:
	pop r16
	ret

h2nib:
	cpi r16,('9'+1)
	brge h2w1               ; not a number - must be a-f or a-f

	subi r16,'0'
	rjmp h2w2
h2w1:
	andi r16,7              ; a-f/A-F becomes 1-6 (a=61, A=41)
	subi r16,-9             ; x--9 == x+9, 1 becomes 0x0a
h2w2:
	lsl r16                 ; shift to upper nibble
	lsl r16
	lsl r16
	lsl r16

	push r17
	ldi r17,4
h2w3:
	rol r16
	rol i0
	rol i1
	dec r17
	brne h2w3
	pop r17
	ret
#endif
;+
; **-hexmem_x-hex dump of memory.
;
; inputs:
;       x   = starting address
;       r16 = byte count
;
; outputs:
;       x   = advanced beyond bytes printed
;       r16 = 0
;-

.global hexmem_x

hexmem_x:
	space
	ld i0,x+
	hexb
	dec r16
	brne hexmem_x
	ret

#endif
