;+
; **-pgetsb-pcode get string byte
;
; inputs:
;       r10 = address in RAM to receive byte
;       r12 = string base address (either in flash or seeprom)
;       r14 = offset to byte in string
;-
.text
    .global pgetsb
pgetsb:        pcode_routine   3
    ;;;pushw z
    movw z,r12
    tstbi zh,0x80               ; is this in serial EEPROM?
    brne pgetsb_seeprom            ; sure enough
    ;;;;lsl zl                      ; nope...code: base address is word address
    ;;;;rol zh                      ; *2 = data pointer
    addw z,r14                  ; add in offset
    lpm                         ; get byte from program memory into r0
    mov i0,r0                   ; move to i0
pgetsb1:
    ;;;popw z
    tst i0                      ; set flags
    rcall r10reloc
    st x+,i0                    ; store byte in LSB
    ret

pgetsb_seeprom:
    andi zh,0x7f                ; clear seeprom flag
    addw z,r14                  ; add in offset
    movw y,z                    ; set seeprom address
    rcall import_seeprom_read   ; read next byte into i0
    rjmp pgetsb1

