;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------
//#include "kernel.inc"

//#define NO_TCP
//#define SINGLE_PACKET_RESPONSE
//#define SERIAL_ALWAYS_BINARY
//#define PCODE_NOOPT       /* turns off register opt in pcode.asm */
//#define PCODE_DEBUG
//#define SIMULATOR
//#define TEST_PCODE
#define WTS_ALWAYS
//#define ICMP_DEBUG
//#define TCP_DEBUG             /* static debug */
//#define     TCP_HEADER_DEBUG    /* runtime-enablable header debug */
//#define TCP_LOGGING_INITIALLY_ON    /* enable runtime header debug */
//#define   TCP_CHECKSUM_ON_THE_FLY
//#define   TCP_PROCESS_ACKS
//#define TCP_GET_DEBUG
//#define RECV_DEBUG
#define RESET_ON_RCV_OVR	/* reset chip on certain buffer overruns */
//#define RECV_OVERRUN_DEBUG
#define ENABLE_WATCHDOG		/* enable watchdog timer */
#define SHOW_ETHER_ADDRESS_ON_BOOT
//#define R2X_DEBUG
//#define R2S_DEBUG
//#define OTHER_PKT_DEBUG   /* packets not destined for me are logged */
//#define XMIT_DEBUG
#define WAIT_TXDONE
//#define REWRITE_CURPAG
//#define BOOTP_DEBUG
//#define BOOTP_DISABLED
#define TIMING_DISABLED
//#define RSADDR_DEBUG
//#define RSCNT_DEBUG

//#define NE_RSTART_OLD_WAY
//#define R2X_OLD_WAY

//#define TIME_ICMP
/*
 * for now, as far as we can tell, TCP_EXTENDED MUST BE DEFINED - otherwise
 * remote connections end up in LAST_ACK state.
 */
#define TCP_EXTENDED      /* extended TCP functions - like ACK processing! */
#define WINDOW_SIZE 8192    /* fixed window size */
//
//  PicoWeb Development System Master Defines
//


#define BREADBOARD
#ifdef BREADBOARD
#define LED_BIT 2            
#else
#define LED_BIT 4            
#define BYTEWIDE_DBUS
#endif


.equ    max_nch = 64            ;;export
.equ    ebuf_len = 32           ;;export
.set    buf_len,16            ;;export
.equ max_boardbuf,ebuf_len
;***************************************************************************
;* A P P L I C A T I O N   N O T E   F O R   T H E   A V R   F A M I L Y
;* 
;* Number		:AVR000
;* File Name		:"8515def.inc"
;* Title		:Register/Bit Definitions for the AT90S8515
;* Date                 :97.12.11
;* Version              :1.20
;* Support telephone	:+47 72 88 87 20 (ATMEL Norway)
;* Support fax		:+47 72 88 87 18 (ATMEL Norway)
;* Support E-mail	:avr@atmel.com
;* Target MCU		:AT90S8515
;*
;* DESCRIPTION
;* When including this file in the assembly program file, all I/O register	
;* names and I/O register bit names appearing in the data book can be used.
;* In addition, the six registers forming the three data pointers X, Y and
;* Z have been assigned names XL - ZH. Highest RAM address for Internal 
;* SRAM is also defined 
;*
;* The Register names are represented by their hexadecimal address.
;* 
;* The Register Bit names are represented by their bit number (0-7).
;* 
;* Please observe the difference in using the bit names with instructions
;* such as "sbr"/"cbr" (set/clear bit in register) and "sbrs"/"sbrc" 
;* (skip if bit in register set/cleared). The following example illustrates
;* this:
;* 
;* in	r16,PORTB		;read PORTB latch
;* sbr	r16,(1<<PB6)+(1<<PB5)	;set PB6 and PB5 (use masks, not bit#)
;* out  PORTB,r16		;output to PORTB
;*
;* in	r16,TIFR		;read the Timer Interrupt Flag Register
;* sbrc	r16,TOV0		;test the overflow flag (use bit#)
;* rjmp	TOV0_is_set		;jump if set
;* ...				;otherwise do something else
;***************************************************************************

;***** Specify Device
;.device AT90S8515

;***** I/O Register Definitions
.equ	sreg	,0x3f
.EQU	SREG	,0X3F
.equ	sph	,0x3e
.EQU	SPH	,0X3E
.equ	spl	,0x3d
.EQU	SPL	,0X3D
.equ	gimsk	,0x3b
.EQU	GIMSK	,0X3B
.equ	gifr	,0x3a
.EQU	GIFR	,0X3A
.equ	timsk	,0x39
.EQU	TIMSK	,0X39
.equ	tifr	,0x38
.EQU	TIFR	,0X38
.equ	mcucr	,0x35
.EQU	MCUCR	,0X35
.equ	tccr0	,0x33
.EQU	TCCR0	,0X33
.equ	tcnt0	,0x32
.EQU	TCNT0	,0X32
.equ	tccr1a	,0x2f
.EQU	TCCR1A	,0X2F
.equ	tccr1b	,0x2e
.EQU	TCCR1B	,0X2E
.equ	tcnt1h	,0x2d
.EQU	TCNT1H	,0X2D
.equ	tcnt1l	,0x2c
.EQU	TCNT1L	,0X2C
.equ	ocr1ah	,0x2b
.EQU	OCR1AH	,0X2B
.equ	ocr1al	,0x2a
.EQU	OCR1AL	,0X2A
.equ	ocr1bh	,0x29
.EQU	OCR1BH	,0X29
.equ	ocr1bl	,0x28
.EQU	OCR1BL	,0X28
.equ	icr1h	,0x25
.EQU	ICR1H	,0X25
.equ	icr1l	,0x24
.EQU	ICR1L	,0X24
.equ	wdtcr	,0x21
.EQU	WDTCR	,0X21
.equ	eearh	,0x1f
.EQU	EEARH	,0X1F
.equ	eearl	,0x1e
.EQU	EEARL	,0X1E
.equ	eedr	,0x1d
.EQU	EEDR	,0X1D
.equ	eecr	,0x1c
.EQU	EECR	,0X1C
.equ	porta	,0x1b
.EQU	PORTA	,0X1B
.equ	ddra	,0x1a
.EQU	DDRA	,0X1A
.equ	pina	,0x19
.EQU	PINA	,0X19
.equ	portb	,0x18
.EQU	PORTB	,0X18
.equ	ddrb	,0x17
.EQU	DDRB	,0X17
.equ	pinb	,0x16
.EQU	PINB	,0X16
.equ	portc	,0x15
.EQU	PORTC	,0X15
.equ	ddrc	,0x14
.EQU	DDRC	,0X14
.equ	pinc	,0x13
.EQU	PINC	,0X13
.equ	portd	,0x12
.EQU	PORTD	,0X12
.equ	ddrd	,0x11
.EQU	DDRD	,0X11
.equ	pind	,0x10
.EQU	PIND	,0X10
.equ	spdr	,0x0f
.EQU	SPDR	,0X0F
.equ	spsr	,0x0e
.EQU	SPSR	,0X0E
.equ	spcr	,0x0d
.EQU	SPCR	,0X0D
.equ	udr	,0x0c
.EQU	UDR	,0X0C
.equ	usr	,0x0b
.EQU	USR	,0X0B
.equ	ucr	,0x0a
.EQU	UCR	,0X0A
.equ	ubrr	,0x09
.EQU	UBRR	,0X09
.equ	acsr	,0x08
.EQU	ACSR	,0X08


;***** Bit Definitions
.equ	int1	,7
.EQU	INT1	,7
.equ	int0	,6
.EQU	INT0	,6

.equ	toie1	,7
.EQU	TOIE1	,7
.equ	ocie1a	,6
.EQU	OCIE1A	,6
.equ	ocie1b	,5
.EQU	OCIE1B	,5
.equ	ticie1	,3
.EQU	TICIE1	,3
.equ	toie0	,1
.EQU	TOIE0	,1

.equ	tov1	,7
.EQU	TOV1	,7
.equ	ocf1a	,6
.EQU	OCF1A	,6
.equ	ocf1b	,5
.EQU	OCF1B	,5
.equ	icf1	,3
.EQU	ICF1	,3
.equ	tov0	,1
.EQU	TOV0	,1

.equ	sre	,7
.EQU	SRE	,7
.equ	srw	,6
.EQU	SRW	,6
.equ	se	,5
.EQU	SE	,5
.equ	sm	,4
.EQU	SM	,4
.equ	isc11	,3
.EQU	ISC11	,3
.equ	isc10	,2
.EQU	ISC10	,2
.equ	isc01	,1
.EQU	ISC01	,1
.equ	isc00	,0
.EQU	ISC00	,0

.equ	com1a1	,7
.EQU	COM1A1	,7
.equ	com1a0	,6
.EQU	COM1A0	,6
.equ	com1b1	,5
.EQU	COM1B1	,5
.equ	com1b0	,4
.EQU	COM1B0	,4
.equ	pwm11	,1
.EQU	PWM11	,1
.equ	pwm10	,0
.EQU	PWM10	,0

.equ	icnc1	,7
.EQU	ICNC1	,7
.equ	ices1	,6
.EQU	ICES1	,6
.equ	ctc1	,3
.EQU	CTC1	,3
.equ	cs12	,2
.EQU	CS12	,2
.equ	cs11	,1
.EQU	CS11	,1
.equ	cs10	,0
.EQU	CS10	,0

.equ	wdtoe	,4
.EQU	WDTOE	,4
.equ	wde	,3
.EQU	WDE	,3
.equ	wdp2	,2
.EQU	WDP2	,2
.equ	wdp1	,1
.EQU	WDP1	,1
.equ	wdp0	,0
.EQU	WDP0	,0

.equ	eemwe	,2
.EQU	EEMWE	,2
.equ	eewe	,1
.EQU	EEWE	,1
.equ	eere	,0
.EQU	EERE	,0

.equ	pa7	,7
.EQU	PA7	,7
.equ	pa6	,6
.EQU	PA6	,6
.equ	pa5	,5
.EQU	PA5	,5
.equ	pa4	,4
.EQU	PA4	,4
.equ	pa3	,3
.EQU	PA3	,3
.equ	pa2	,2
.EQU	PA2	,2
.equ	pa1	,1
.EQU	PA1	,1
.equ	pa0	,0
.EQU	PA0	,0

.equ	dda7	,7
.EQU	DDA7	,7
.equ	dda6	,6
.EQU	DDA6	,6
.equ	dda5	,5
.EQU	DDA5	,5
.equ	dda4	,4
.EQU	DDA4	,4
.equ	dda3	,3
.EQU	DDA3	,3
.equ	dda2	,2
.EQU	DDA2	,2
.equ	dda1	,1
.EQU	DDA1	,1
.equ	dda0	,0
.EQU	DDA0	,0

.equ	pina7	,7
.EQU	PINA7	,7
.equ	pina6	,6
.EQU	PINA6	,6
.equ	pina5	,5
.EQU	PINA5	,5
.equ	pina4	,4
.EQU	PINA4	,4
.equ	pina3	,3
.EQU	PINA3	,3
.equ	pina2	,2
.EQU	PINA2	,2
.equ	pina1	,1
.EQU	PINA1	,1
.equ	pina0	,0
.EQU	PINA0	,0

.equ	pb7	,7
.EQU	PB7	,7
.equ	pb6	,6
.EQU	PB6	,6
.equ	pb5	,5
.EQU	PB5	,5
.equ	pb4	,4
.EQU	PB4	,4
.equ	pb3	,3
.EQU	PB3	,3
.equ	pb2	,2
.EQU	PB2	,2
.equ	pb1	,1
.EQU	PB1	,1
.equ	pb0	,0
.EQU	PB0	,0

.equ	ddb7	,7
.EQU	DDB7	,7
.equ	ddb6	,6
.EQU	DDB6	,6
.equ	ddb5	,5
.EQU	DDB5	,5
.equ	ddb4	,4
.EQU	DDB4	,4
.equ	ddb3	,3
.EQU	DDB3	,3
.equ	ddb2	,2
.EQU	DDB2	,2
.equ	ddb1	,1
.EQU	DDB1	,1
.equ	ddb0	,0
.EQU	DDB0	,0

.equ	pinb7	,7
.EQU	PINB7	,7
.equ	pinb6	,6
.EQU	PINB6	,6
.equ	pinb5	,5
.EQU	PINB5	,5
.equ	pinb4	,4
.EQU	PINB4	,4
.equ	pinb3	,3
.EQU	PINB3	,3
.equ	pinb2	,2
.EQU	PINB2	,2
.equ	pinb1	,1
.EQU	PINB1	,1
.equ	pinb0	,0
.EQU	PINB0	,0

.equ	pc7	,7
.EQU	PC7	,7
.equ	pc6	,6
.EQU	PC6	,6
.equ	pc5	,5
.EQU	PC5	,5
.equ	pc4	,4
.EQU	PC4	,4
.equ	pc3	,3
.EQU	PC3	,3
.equ	pc2	,2
.EQU	PC2	,2
.equ	pc1	,1
.EQU	PC1	,1
.equ	pc0	,0
.EQU	PC0	,0

.equ	ddc7	,7
.EQU	DDC7	,7
.equ	ddc6	,6
.EQU	DDC6	,6
.equ	ddc5	,5
.EQU	DDC5	,5
.equ	ddc4	,4
.EQU	DDC4	,4
.equ	ddc3	,3
.EQU	DDC3	,3
.equ	ddc2	,2
.EQU	DDC2	,2
.equ	ddc1	,1
.EQU	DDC1	,1
.equ	ddc0	,0
.EQU	DDC0	,0

.equ	pinc7	,7
.EQU	PINC7	,7
.equ	pinc6	,6
.EQU	PINC6	,6
.equ	pinc5	,5
.EQU	PINC5	,5
.equ	pinc4	,4
.EQU	PINC4	,4
.equ	pinc3	,3
.EQU	PINC3	,3
.equ	pinc2	,2
.EQU	PINC2	,2
.equ	pinc1	,1
.EQU	PINC1	,1
.equ	pinc0	,0
.EQU	PINC0	,0

.equ	pd7	,7
.EQU	PD7	,7
.equ	pd6	,6
.EQU	PD6	,6
.equ	pd5	,5
.EQU	PD5	,5
.equ	pd4	,4
.EQU	PD4	,4
.equ	pd3	,3
.EQU	PD3	,3
.equ	pd2	,2
.EQU	PD2	,2
.equ	pd1	,1
.EQU	PD1	,1
.equ	pd0	,0
.EQU	PD0	,0

.equ	ddd7	,7
.EQU	DDD7	,7
.equ	ddd6	,6
.EQU	DDD6	,6
.equ	ddd5	,5
.EQU	DDD5	,5
.equ	ddd4	,4
.EQU	DDD4	,4
.equ	ddd3	,3
.EQU	DDD3	,3
.equ	ddd2	,2
.EQU	DDD2	,2
.equ	ddd1	,1
.EQU	DDD1	,1
.equ	ddd0	,0
.EQU	DDD0	,0

.equ	pind7	,7
.EQU	PIND7	,7
.equ	pind6	,6
.EQU	PIND6	,6
.equ	pind5	,5
.EQU	PIND5	,5
.equ	pind4	,4
.EQU	PIND4	,4
.equ	pind3	,3
.EQU	PIND3	,3
.equ	pind2	,2
.EQU	PIND2	,2
.equ	pind1	,1
.EQU	PIND1	,1
.equ	pind0	,0
.EQU	PIND0	,0

.equ	rxc	,7
.EQU	RXC	,7
.equ	txc	,6
.EQU	TXC	,6
.equ	udre	,5
.EQU	UDRE	,5
.equ	fe	,4
.EQU	FE	,4
.equ	or	,3
.EQU	OR	,3

.equ	spie	,7
.EQU	SPIE	,7
.equ	spe	,6
.EQU	SPE	,6
.equ	dord	,5
.EQU	DORD	,5
.equ	mstr	,4
.EQU	MSTR	,4
.equ	cpol	,3
.EQU	CPOL	,3
.equ	cpha	,2
.EQU	CPHA	,2
.equ	spr1	,1
.EQU	SPR1	,1
.equ	spr0	,0
.EQU	SPR0	,0

.equ	spif	,7
.EQU	SPIF	,7
.equ	wcol	,6
.EQU	WCOL	,6

.equ	rxcie	,7
.EQU	RXCIE	,7
.equ	txcie	,6
.EQU	TXCIE	,6
.equ	udrie	,5
.EQU	UDRIE	,5
.equ	rxen	,4
.EQU	RXEN	,4
.equ	txen	,3
.EQU	TXEN	,3
.equ	chr9	,2
.EQU	CHR9	,2
.equ	rxb8	,1
.EQU	RXB8	,1
.equ	txb8	,0
.EQU	TXB8	,0

.equ	acd	,7
.EQU	ACD	,7
.equ	aco	,5
.EQU	ACO	,5
.equ	aci	,4
.EQU	ACI	,4
.equ	acie	,3
.EQU	ACIE	,3
.equ	acic	,2
.EQU	ACIC	,2
.equ	acis1	,1
.EQU	ACIS1	,1
.equ	acis0	,0
.EQU	ACIS0	,0

.equ	xl	,r26
.EQU	XL	,R26
.equ	xh	,r27
.EQU	XH	,R27
.equ	yl	,r28
.EQU	YL	,R28
.equ	yh	,r29
.EQU	YH	,R29
.equ	zl	,r30
.EQU	ZL	,R30
.equ	zh	,r31
.EQU	ZH	,R31

.equ 	ramend ,0x25f	;last on-chip sram location
.EQU 	RAMEND ,0X25F	;LAST ON-CHIP SRAM LOCATION

.equ	int0addr,0x001	;external interrupt0 vector address
.EQU	INT0ADDR,0X001	;EXTERNAL INTERRUPT0 VECTOR ADDRESS
.equ	int1addr,0x002	;external interrupt1 vector address
.EQU	INT1ADDR,0X002	;EXTERNAL INTERRUPT1 VECTOR ADDRESS
.equ	icp1addr,0x003	;input capture1 interrupt vector address
.EQU	ICP1ADDR,0X003	;INPUT CAPTURE1 INTERRUPT VECTOR ADDRESS
.equ	oc1aaddr,0x004	;output compare1a interrupt vector address
.EQU	OC1AADDR,0X004	;OUTPUT COMPARE1A INTERRUPT VECTOR ADDRESS
.equ	oc1baddr,0x005	;output compare1b interrupt vector address
.EQU	OC1BADDR,0X005	;OUTPUT COMPARE1B INTERRUPT VECTOR ADDRESS
.equ	ovf1addr,0x006	;overflow1 interrupt vector address
.EQU	OVF1ADDR,0X006	;OVERFLOW1 INTERRUPT VECTOR ADDRESS
.equ	ovf0addr,0x007	;overflow0 interrupt vector address
.EQU	OVF0ADDR,0X007	;OVERFLOW0 INTERRUPT VECTOR ADDRESS
.equ	spiaddr ,0x008	;spi interrupt vector address
.EQU	SPIADDR ,0X008	;SPI INTERRUPT VECTOR ADDRESS
.equ	urxcaddr,0x009	;uart receive complete interrupt vector address
.EQU	URXCADDR,0X009	;UART RECEIVE COMPLETE INTERRUPT VECTOR ADDRESS
.equ	udreaddr,0x00a	;uart data register empty interrupt vector address
.EQU	UDREADDR,0X00A	;UART DATA REGISTER EMPTY INTERRUPT VECTOR ADDRESS
.equ	utxcaddr,0x00b	;uart transmit complete interrupt vector address
.EQU	UTXCADDR,0X00B	;UART TRANSMIT COMPLETE INTERRUPT VECTOR ADDRESS
.equ	aciaddr ,0x00c	;analog comparator interrupt vector address
.EQU	ACIADDR ,0X00C	;ANALOG COMPARATOR INTERRUPT VECTOR ADDRESS
; The EN registers - the DS8390 chip registers 
; There are two (really 3) pages of registers in the chip. You select 
; which page you want, then address them at offsets 00-0F from base. 
; The chip command register (EN_CCMD) appears in both pages. 
; EN_OFF is the offset from the boards base register to the EN registers. 
;
.equ eaddr_len , 6 ;               bytes in an ether address 
.EQU EADDR_LEN , 6 ;               BYTES IN AN ETHER ADDRESS 
;
.equ en_ccmd , 0x000 ;      chips command register 
.EQU EN_CCMD , 0X000 ;      CHIPS COMMAND REGISTER 
;
; Page 0 
;
.equ en0_cldalo , 0x001 ;  	 low byte of current local dma addr  rd 
.EQU EN0_CLDALO , 0X001 ;  	 LOW BYTE OF CURRENT LOCAL DMA ADDR  RD 
.equ en0_startpg , 0x001 ;  	 starting page of ring bfr wr 
.EQU EN0_STARTPG , 0X001 ;  	 STARTING PAGE OF RING BFR WR 
.equ en0_cldahi , 0x002 ;  	 high byte of current local dma addr  rd 
.EQU EN0_CLDAHI , 0X002 ;  	 HIGH BYTE OF CURRENT LOCAL DMA ADDR  RD 
.equ en0_stoppg , 0x002 ;  	 ending page +1 of ring bfr wr 
.EQU EN0_STOPPG , 0X002 ;  	 ENDING PAGE +1 OF RING BFR WR 
.equ en0_boundary , 0x003 ;  	 boundary page of ring bfr rd wr 
.EQU EN0_BOUNDARY , 0X003 ;  	 BOUNDARY PAGE OF RING BFR RD WR 
.equ en0_tsr , 0x004 ;  	 transmit status reg rd 
.EQU EN0_TSR , 0X004 ;  	 TRANSMIT STATUS REG RD 
.equ en0_tpsr , 0x004 ;  	 transmit starting page wr 
.EQU EN0_TPSR , 0X004 ;  	 TRANSMIT STARTING PAGE WR 
.equ en0_ncr , 0x005 ;  	 number of collision reg rd 
.EQU EN0_NCR , 0X005 ;  	 NUMBER OF COLLISION REG RD 
.equ en0_tcntlo , 0x005 ;  	 low  byte of tx byte count wr 
.EQU EN0_TCNTLO , 0X005 ;  	 LOW  BYTE OF TX BYTE COUNT WR 
.equ en0_fifo , 0x006 ;  	 fifo rd 
.EQU EN0_FIFO , 0X006 ;  	 FIFO RD 
.equ en0_tcnthi , 0x006 ;  	 high byte of tx byte count wr 
.EQU EN0_TCNTHI , 0X006 ;  	 HIGH BYTE OF TX BYTE COUNT WR 
.equ en0_isr , 0x007 ;  	 interrupt status reg rd wr 
.EQU EN0_ISR , 0X007 ;  	 INTERRUPT STATUS REG RD WR 
.equ en0_crdalo , 0x008 ;  	 low byte of current remote dma address rd 
.EQU EN0_CRDALO , 0X008 ;  	 LOW BYTE OF CURRENT REMOTE DMA ADDRESS RD 
.equ en0_rsarlo , 0x008 ;  	 remote start address reg 0 
.EQU EN0_RSARLO , 0X008 ;  	 REMOTE START ADDRESS REG 0 
.equ en0_crdahi , 0x009 ;  	 high byte of current remote dma address rd 
.EQU EN0_CRDAHI , 0X009 ;  	 HIGH BYTE OF CURRENT REMOTE DMA ADDRESS RD 
.equ en0_rsarhi , 0x009 ;  	 remote start address reg 1 
.EQU EN0_RSARHI , 0X009 ;  	 REMOTE START ADDRESS REG 1 
.equ en0_rcntlo , 0x00a ;  	 remote byte count reg wr 
.EQU EN0_RCNTLO , 0X00A ;  	 REMOTE BYTE COUNT REG WR 
.equ en0_rcnthi , 0x00b ;  	 remote byte count reg wr 
.EQU EN0_RCNTHI , 0X00B ;  	 REMOTE BYTE COUNT REG WR 
.equ en0_rsr , 0x00c ;  	 rx status reg rd 
.EQU EN0_RSR , 0X00C ;  	 RX STATUS REG RD 
.equ en0_rxcr , 0x00c ;  	 rx control reg wr 
.EQU EN0_RXCR , 0X00C ;  	 RX CONTROL REG WR 
.equ en0_txcr , 0x00d ;  	 tx control reg wr 
.EQU EN0_TXCR , 0X00D ;  	 TX CONTROL REG WR 
.equ en0_counter0 , 0x00d ;  	 rcv alignment error counter rd 
.EQU EN0_COUNTER0 , 0X00D ;  	 RCV ALIGNMENT ERROR COUNTER RD 
.equ en0_dcfg , 0x00e ;  	 data configuration reg wr 
.EQU EN0_DCFG , 0X00E ;  	 DATA CONFIGURATION REG WR 
.equ en0_counter1 , 0x00e ;  	 rcv crc error counter rd 
.EQU EN0_COUNTER1 , 0X00E ;  	 RCV CRC ERROR COUNTER RD 
.equ en0_imr , 0x00f ;  	 interrupt mask reg wr 
.EQU EN0_IMR , 0X00F ;  	 INTERRUPT MASK REG WR 
.equ en0_counter2 , 0x00f ;  	 rcv missed frame error counter rd 
.EQU EN0_COUNTER2 , 0X00F ;  	 RCV MISSED FRAME ERROR COUNTER RD 
;
; Page 1 
;
.equ en1_phys , 0x001 ;  	 this boards physical enet addr rd wr 
.EQU EN1_PHYS , 0X001 ;  	 THIS BOARDS PHYSICAL ENET ADDR RD WR 
.equ en1_curpag , 0x007 ;  	 current memory page rd wr 
.EQU EN1_CURPAG , 0X007 ;  	 CURRENT MEMORY PAGE RD WR 
.equ en1_mult , 0x008 ;  	 multicast filter mask array (8 bytes) rd wr 
.EQU EN1_MULT , 0X008 ;  	 MULTICAST FILTER MASK ARRAY (8 BYTES) RD WR 
;
; Chip commands in EN_CCMD 
.equ enc_stop , 0x001 ;  	 stop the chip 
.EQU ENC_STOP , 0X001 ;  	 STOP THE CHIP 
.equ enc_start , 0x002 ;  	 start the chip 
.EQU ENC_START , 0X002 ;  	 START THE CHIP 
.equ enc_trans , 0x004 ;  	 transmit a frame 
.EQU ENC_TRANS , 0X004 ;  	 TRANSMIT A FRAME 
.equ enc_rread , 0x008 ;  	 remote read 
.EQU ENC_RREAD , 0X008 ;  	 REMOTE READ 
.equ enc_rwrite , 0x010 ;  	 remote write 
.EQU ENC_RWRITE , 0X010 ;  	 REMOTE WRITE 
.equ enc_nodma , 0x020 ;  	 no remote dma used on this card 
.EQU ENC_NODMA , 0X020 ;  	 NO REMOTE DMA USED ON THIS CARD 
.equ enc_page0 , 0x000 ;  	 select page 0 of chip registers 
.EQU ENC_PAGE0 , 0X000 ;  	 SELECT PAGE 0 OF CHIP REGISTERS 
.equ enc_page1 , 0x040 ;  	 select page 1 of chip registers 
.EQU ENC_PAGE1 , 0X040 ;  	 SELECT PAGE 1 OF CHIP REGISTERS 
.equ enc_page2 , 0x080 ;         page 2
.EQU ENC_PAGE2 , 0X080 ;         PAGE 2
.equ enc_page3 , 0x0c0 ;         page 3 (realtek rtl8019as chip)
.EQU ENC_PAGE3 , 0X0C0 ;         PAGE 3 (REALTEK RTL8019AS CHIP)
;
; Commands for EN0_RXCR - RX control reg 
.equ enrxcr_crc , 0x001 ;  	 save error pkts 
.EQU ENRXCR_CRC , 0X001 ;  	 SAVE ERROR PKTS 
.equ enrxcr_runt , 0x002 ;  	 accept runt pkt 
.EQU ENRXCR_RUNT , 0X002 ;  	 ACCEPT RUNT PKT 
.equ enrxcr_bcst , 0x004 ;  	 accept broadcasts 
.EQU ENRXCR_BCST , 0X004 ;  	 ACCEPT BROADCASTS 
.equ enrxcr_multi , 0x008 ;  	 multicast (if pass filter) 
.EQU ENRXCR_MULTI , 0X008 ;  	 MULTICAST (IF PASS FILTER) 
.equ enrxcr_promp , 0x010 ;  	 promiscuous physical addresses 
.EQU ENRXCR_PROMP , 0X010 ;  	 PROMISCUOUS PHYSICAL ADDRESSES 
.equ enrxcr_mon , 0x020 ;  	 monitor mode (no packets rcvd) 
.EQU ENRXCR_MON , 0X020 ;  	 MONITOR MODE (NO PACKETS RCVD) 
;
; Bits in EN0_TXCR - transmit control reg 
.equ entxcr_crc , 0x001 ;  		 inhibit crc, do not append crc 
.EQU ENTXCR_CRC , 0X001 ;  		 INHIBIT CRC, DO NOT APPEND CRC 
.equ entxcr_loop , 0x002 ;  		 set loopback mode 
.EQU ENTXCR_LOOP , 0X002 ;  		 SET LOOPBACK MODE 
.equ entxcr_lb01 , 0x006 ;  		 encoded loopback control 
.EQU ENTXCR_LB01 , 0X006 ;  		 ENCODED LOOPBACK CONTROL 
.equ entxcr_atd , 0x008 ;  		 auto tx disable 
.EQU ENTXCR_ATD , 0X008 ;  		 AUTO TX DISABLE 
.equ entxcr_ofst , 0x010 ;  		 collision offset enable 
.EQU ENTXCR_OFST , 0X010 ;  		 COLLISION OFFSET ENABLE 
;
; Bits in EN0_DCFG - Data config register 
#ifdef BYTEWIDE_DBUS
.equ endcfg_wts , 0x000 ;  	 byte transfer mode selection 
.EQU ENDCFG_WTS , 0X000 ;  	 BYTE TRANSFER MODE SELECTION 
#else
.equ endcfg_wts , 0x001 ;  	 word transfer mode selection 
.EQU ENDCFG_WTS , 0X001 ;  	 WORD TRANSFER MODE SELECTION 
#endif
.equ endcfg_bos , 0x002 ;  	 byte order selection 
.EQU ENDCFG_BOS , 0X002 ;  	 BYTE ORDER SELECTION 
.equ endcfg_las , 0x004 ;  	 long addr selection 
.EQU ENDCFG_LAS , 0X004 ;  	 LONG ADDR SELECTION 
.equ endcfg_bms , 0x008 ;  	 burst mode selection 
.EQU ENDCFG_BMS , 0X008 ;  	 BURST MODE SELECTION 
.equ endcfg_arm , 0x010 ;  	 autoinitialize remote 
.EQU ENDCFG_ARM , 0X010 ;  	 AUTOINITIALIZE REMOTE 
.equ endcfg_ft00 , 0x000 ;  	 burst length selection 
.EQU ENDCFG_FT00 , 0X000 ;  	 BURST LENGTH SELECTION 
.equ endcfg_ft01 , 0x020 ;  	 burst length selection 
.EQU ENDCFG_FT01 , 0X020 ;  	 BURST LENGTH SELECTION 
.equ endcfg_ft10 , 0x040 ;  	 burst length selection 
.EQU ENDCFG_FT10 , 0X040 ;  	 BURST LENGTH SELECTION 
.equ endcfg_ft11 , 0x060 ;  	 burst length selection 
.EQU ENDCFG_FT11 , 0X060 ;  	 BURST LENGTH SELECTION 
;
; Bits in EN0_ISR - Interrupt status register 
.equ enisr_rx , 0x001 ;  	 receiver, no error 
.EQU ENISR_RX , 0X001 ;  	 RECEIVER, NO ERROR 
.equ enisr_tx , 0x002 ;  	 transmitter, no error 
.EQU ENISR_TX , 0X002 ;  	 TRANSMITTER, NO ERROR 
.equ enisr_rx_err , 0x004 ;  	 receiver, with error 
.EQU ENISR_RX_ERR , 0X004 ;  	 RECEIVER, WITH ERROR 
.equ enisr_tx_err , 0x008 ;  	 transmitter, with error 
.EQU ENISR_TX_ERR , 0X008 ;  	 TRANSMITTER, WITH ERROR 
.equ enisr_over , 0x010 ;  	 receiver overwrote the ring 
.EQU ENISR_OVER , 0X010 ;  	 RECEIVER OVERWROTE THE RING 
.equ enisr_counters , 0x020 ;  	 counters need emptying 
.EQU ENISR_COUNTERS , 0X020 ;  	 COUNTERS NEED EMPTYING 
.equ enisr_rdc , 0x040 ;  	 remote dma complete 
.EQU ENISR_RDC , 0X040 ;  	 REMOTE DMA COMPLETE 
.equ enisr_reset , 0x080 ;  	 reset completed 
.EQU ENISR_RESET , 0X080 ;  	 RESET COMPLETED 
;
.equ enisr_all , 0x03f ;  	 interrupts we will enable 
.EQU ENISR_ALL , 0X03F ;  	 INTERRUPTS WE WILL ENABLE 
;
; Bits in received packet status byte and EN0_RSR 
.equ enrsr_rxok , 0x001 ;  	 received a good packet 
.EQU ENRSR_RXOK , 0X001 ;  	 RECEIVED A GOOD PACKET 
.equ enrsr_crc , 0x002 ;  	 crc error 
.EQU ENRSR_CRC , 0X002 ;  	 CRC ERROR 
.equ enrsr_fae , 0x004 ;  	 frame alignment error 
.EQU ENRSR_FAE , 0X004 ;  	 FRAME ALIGNMENT ERROR 
.equ enrsr_fo , 0x008 ;  	 fifo overrun 
.EQU ENRSR_FO , 0X008 ;  	 FIFO OVERRUN 
.equ enrsr_mpa , 0x010 ;  	 missed pkt 
.EQU ENRSR_MPA , 0X010 ;  	 MISSED PKT 
.equ enrsr_phy , 0x020 ;  	 physical/multicase address 
.EQU ENRSR_PHY , 0X020 ;  	 PHYSICAL/MULTICASE ADDRESS 
.equ enrsr_dis , 0x040 ;  	 receiver disable. set in monitor mode 
.EQU ENRSR_DIS , 0X040 ;  	 RECEIVER DISABLE. SET IN MONITOR MODE 
.equ enrsr_def , 0x080 ;  	 deferring 
.EQU ENRSR_DEF , 0X080 ;  	 DEFERRING 
;
; Bits in EN0_TSR -  TX status reg 
;
.equ entsr_ptx , 0x001 ;  	 packet transmitted without error 
.EQU ENTSR_PTX , 0X001 ;  	 PACKET TRANSMITTED WITHOUT ERROR 
.equ entsr_dfr , 0x002 ;  	 non deferred tx 
.EQU ENTSR_DFR , 0X002 ;  	 NON DEFERRED TX 
.equ entsr_coll , 0x004 ;  	 collided at least once 
.EQU ENTSR_COLL , 0X004 ;  	 COLLIDED AT LEAST ONCE 
.equ entsr_coll16 , 0x008 ;  	 collided 16 times and was dropped 
.EQU ENTSR_COLL16 , 0X008 ;  	 COLLIDED 16 TIMES AND WAS DROPPED 
.equ entsr_crs , 0x010 ;  	 carrier sense lost 
.EQU ENTSR_CRS , 0X010 ;  	 CARRIER SENSE LOST 
.equ entsr_fu , 0x020 ;  	 tx fifo underrun 
.EQU ENTSR_FU , 0X020 ;  	 TX FIFO UNDERRUN 
.equ entsr_cd , 0x040 ;  	 collision detect heartbeat 
.EQU ENTSR_CD , 0X040 ;  	 COLLISION DETECT HEARTBEAT 
.equ entsr_owc , 0x080 ;  	 out of window collision 
.EQU ENTSR_OWC , 0X080 ;  	 OUT OF WINDOW COLLISION 
;
; Description of header of each packet in receive area of memory 
;
.equ en_rbuf_stat , 0 ;  	 received frame status 
.EQU EN_RBUF_STAT , 0 ;  	 RECEIVED FRAME STATUS 
.equ en_rbuf_nxt_pg , 1 ;  	 page after this frame 
.EQU EN_RBUF_NXT_PG , 1 ;  	 PAGE AFTER THIS FRAME 
.equ en_rbuf_size_lo , 2 ;  	 length of this frame 
.EQU EN_RBUF_SIZE_LO , 2 ;  	 LENGTH OF THIS FRAME 
.equ en_rbuf_size_hi , 3 ;  	 length of this frame 
.EQU EN_RBUF_SIZE_HI , 3 ;  	 LENGTH OF THIS FRAME 
.equ en_rbuf_nhdr , 4 ;  	 length of above header area 
.EQU EN_RBUF_NHDR , 4 ;  	 LENGTH OF ABOVE HEADER AREA 
;
;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------

.macro stxi p0
    ldi w,\p0
    st x+,w
.endm

.macro bss name,size
.section .bss
\name: .skip \size
.data
.endm

.macro global_bss name,size
    bss \name,\size
    .global \name
.endm

.macro global_common name,size
    .global \name
    .comm \name,\size,1
.endm

.equ pcode_signature , 0        ;;; top 3 bits now ind. disable flags
.equ pcode_arg_mask , 3
.equ NO_P1_IND , 0x8000
.equ NO_P2_IND , 0x4000
.equ NO_P3_IND , 0x2000

.macro andwi p0 ,p1, l=l, h=h
    andi \p0\l,lo8(\p1)
    andi \p0\h,hi8(\p1)
.endm

.macro pcode_routine p0
    .word \p0|pcode_signature
.endm

.macro ldsw p0 ,p1, l=l, h=h
    lds \p0\l,\p1
    lds \p0\h,\p1+1
.endm

.macro stsw p0 ,p1, l=l, h=h
    sts \p0,\p1\l
    sts \p0+1,\p1\h
.endm

.macro pushw p0, l=l, h=h
    push \p0\h
    push \p0\l
.endm

.macro popw p0, l=l, h=h
    pop \p0\l
    pop \p0\h
.endm

.macro shrw p0, l=l, h=h
    lsr \p0\h
    ror \p0\l
.endm

.macro shlw p0, l=l, h=h
    lsl \p0\l
    rol \p0\h
.endm

.macro tstb p0 ,p1
    mov w,\p1
    and w,\p0
.endm

.macro tstbi p0 ,p1
    ldi w,\p1
    and w,\p0
.endm

.macro cmpw p0 ,p1, l=l, h=h
    cp \p0\l,\p1\l
    cpc \p0\h,\p1\h
.endm

.macro cmpwi p0 ,p1, l=l, h=h
    cpi \p0\l,lo8(\p1)
    ldi w,hi8(\p1)
    cpc \p0\h,w
.endm

.macro  coroutine_call
    pop zh
    pop zl
    icall
.endm

.macro coroutine_done
    pop zh
    pop zl
.endm

.macro coroutine_return
    push    zl
    push zh
    ret
.endm

.macro coroutine_setup
    push    zl
    push    zh
.endm

.macro putchar p0
	ldi	ch,\p0
	rcall do_putchar
.endm

.macro hexb
    rcall do_hexb
.endm

.macro space
    rcall do_space
.endm

.macro crlf
    rcall do_crlf
.endm

.macro addwi p0 ,p1, l=l, h=h
    ldi w,lo8(\p1)
    add \p0\l,w
    ldi w,hi8(\p1)
    adc \p0\h,w
.endm

.macro addw p0 ,p1, l=l, h=h
    add \p0\l,\p1\l
    adc \p0\h,\p1\h
.endm

.macro subwi p0 ,p1, l=l, h=h
    ldi w,lo8(\p1)
    sub \p0\l,w
    ldi w,hi8(\p1)
    sbc \p0\h,w
.endm

.macro subw p0 ,p1, l=l, h=h
    sub \p0\l,\p1\l
    sbc \p0\h,\p1\h
.endm

.macro movwi p0 ,p1, l=l, h=h
	ldi	\p0\l,lo8(\p1)
	ldi	\p0\h,hi8(\p1)
.endm

.macro clrw p0, l=l, h=h
    clr \p0\l
    clr \p0\h
.endm

.macro decw p0, l=l, h=h
    subi \p0\l,1
    sbci \p0\h,0
.endm

.macro incw p0, l=l, h=h
    subi \p0\l,-1
    sbci \p0\h,-1
.endm

.macro ldsbw p0 ,p1, l=l, h=h
	lds	\p0\l,\p1
    clr \p0\h
.endm

.macro movw p0 ,p1, l=l, h=h
    mov \p0\l,\p1\l
    mov \p0\h,\p1\h
.endm

.macro outstr p0
    rcall do_outstr
	.word	\p0
.endm

.macro hexy
    rcall hexy
.endm

.macro outstrs p0
	ldi	yl,lo8(\p0)
	ldi	yh,hi8(\p0)
    rcall do_outstrs
.endm

.macro setport p0 ,p1
    ldi r16,\p1
    mov i0,r16
    ldi r16,\p0
    rcall isa_out
.endm

.macro isa_out
    rcall   isa_out
.endm

.equ r0l ,r0
.equ r0h ,r1
.equ r1l ,r1
.equ i0 ,r2
.equ r1h ,r2
.equ r2l ,r2
.equ i1 ,r3
.equ r2h ,r3
.equ r3l ,r3
;.equ i2 ,r4
;.equ r3h ,r4
;.equ r4l ,r4
;.equ r4h ,r5
;.equ r5l ,r5
.equ pl,r4
.equ ph,r5  ; pcode PC low, high
;.equ r5h ,r6
.equ r6l ,r6
.equ r6h ,r7
.equ r7l ,r7
.equ r7h ,r8
.equ r8l ,r8
.equ r8h ,r9
.equ r9l ,r9
.equ r9h ,r10
.equ r10l ,r10
.equ r10h ,r11
.equ r11l ,r11
.equ r11h ,r12
.equ r12l ,r12
.equ r12h ,r13
.equ r13l ,r13
.equ r13h ,r14
.equ r14l ,r14
.equ r14h ,r15
.equ r15l ,r15
.equ r15h ,r16
.equ r16l ,r16
.equ r16h ,r17
.equ r17l ,r17
.equ r17h ,r18
.equ r18l ,r18
.equ r18h ,r19
.equ r19l ,r19
.equ r19h ,r20
.equ r20l ,r20
.equ r20h ,r21
.equ r21l ,r21
.equ r21h ,r22
.equ r22l ,r22
.equ r22h ,r23
.equ r23l ,r23
.equ r23h ,r24
;; reserved for macros.
.equ r24l , r24
.equ r24h , r25
.equ ch , r25 ; for putchar

;.equ wl   ,r24
.equ w    ,r25
;.equ wh   ,r25
;.equ w1   ,r25

.equ r25h ,r26
.equ r26l ,r26
.equ xl  ,r26
.equ r26h ,r27
.equ r27l ,r27
.equ xh  ,r27

.equ r27h ,r28
.equ r28l ,r28
.equ yll  ,r28
.equ r28h ,r29
.equ r29l ,r29
.equ ylh  ,r29

.equ r29h ,r30
.equ r30l ,r30
.equ zl  ,r30
.equ r30h ,r31
.equ r31l ,r31
.equ zh  ,r31

.macro asm
.word 0
.endm

.macro pend
.word 0
.endm

.macro pbegin
rcall pcode
.endm

.macro export
.endm

.macro f2x_checksum p0 ,p1, l=l, h=h
    add xl,\p0\l
    adc xh,\p0\h
    clr \p1
    adc xl,\p1
    adc xh,\p1
.endm

.equ XX , 0x8000                        ; eXtended operand fetching
.equ XW , 0x4000                        ; word mode, else byte
.equ XS , 0x2000                        ; swap bytes
.equ BP , 0x1f00                       ; base of BP-relative address space
#define CODEP(x) pm(x)

.equ    stackend , ramend

;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------

#if defined(TIMING_DISABLED)

.macro zero_timer
.endm
.macro show_timer
.endm
.macro zero_timer_inline
.endm
.macro show_timer_inline
.endm

#else

.macro zero_timer
    rcall do_zero_timer
.endm
.macro show_timer
    rcall do_show_timer
.endm

.macro zero_timer_inline
	push	r17
	clr	r17
	out	tcnt1h,r17	; this order is key!
	out	tcnt1l,r17	; write LSB last!
	pop	r17
	nop			; balance timer read time
	nop
.endm

.macro show_timer_inline
	push yl
    push yh
	push	i1
	in	yl,tcnt1l
	in	yh,tcnt1h
	ldi	ch,'['
	rcall	do_putchar
    rcall   hexy
	ldi	ch,']'
	rcall	do_putchar
	pop yh
    pop yl
.endm

#endif
;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------

; ne2000.inc.

.equ ne_dataport , 0x10
.equ ENDCFG,0x48

.macro ne_rstart
    rcall   ne_rstart
.endm
;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------

#if !defined(TCPIP_INC_INCLUDED)
#define TCPIP_INC_INCLUDED
#define _FIN     0x0001
#define _SYN     0x0002
#define _RST     0x0004
#define _PUSH    0x0008
#define _ACK     0x0010
#define _DO_B(x)  (((x/4)+5)<<12)
#define _DO      _DO_B(0)

#define ETH_DEST 0
#define ETH_SRC ETH_DEST+6
#define ETH_PT ETH_SRC+6
#define IPH  ETH_PT+2
#define IP_HVTOS   IPH+0
#define IP_LEN     IPH+2
#define IP_ID      IPH+4
#define IP_FFO     IPH+6
#define IP_TTLP    IPH+8
#define IP_CHKSUM  IPH+10
#define IP_SRCADDR IPH+12
#define IP_DSTADDR IPH+16
#define IP_HEADER_LEN  20
#define IPD IPH+IP_HEADER_LEN

#define TCP_HEADER  IPD+0
#define TCP_SP      IPD+0
#define TCP_DP      IPD+2
#define TCP_SEQ     IPD+4
#define TCP_ACK     IPD+8
#define TCP_FLAGS   IPD+12
#define TCP_WIN     IPD+14
#define TCP_CHKSUM  IPD+16
#define TCP_URG     IPD+18
#define TCP_DATA    IPD+20
#define TCP_HEADER_LEN  20

#define UDP_HEADER  IPD+0
#define UDP_SP          UDP_HEADER+0
#define UDP_DP          UDP_HEADER+2
#define UDP_LEN         UDP_HEADER+4
#define UDP_CHKSUM      UDP_HEADER+6
#define UDP_DATA        UDP_HEADER+8
#define UDP_HEADER_LEN 8

#define ETH_PT_ARP  0x0608
#define AH_HWTYPE   ETH_PT+2
#define     ARP_HWTYPE_ETHER    0x0100
#define AH_PROTTYPE AH_HWTYPE+2
#define     ARP_PROTTYPE_IP     0x0008
#define AH_PROTALEN AH_PROTTYPE+2
#define     ARP_PROTALEN        0x0406
#define AH_OPCODE   AH_PROTALEN+2
#define     ARP_OPCODE_REQUEST  0x0100
#define     ARP_OPCODE_REPLY    0x0200
#define AH_SRCETH   AH_OPCODE+2
#define AH_SRCIP    AH_SRCETH+6
#define AH_DSTETH   AH_SRCIP+4
#define AH_DSTIP    AH_DSTETH+6
#define AH_LEN      AH_DSTIP+4

#define SET_ADDL(val)      \
    .dw pmovwi,buf+4,byte4(val)|(byte3(val)<<8),pmovwi,buf+6,byte2(val)|(low(val)<<8)
#define R2X_ADDL(to,from)   \
    .dw pr2s,buf,from,4,paddn,buf,buf+4,4,ps2x,to,buf,4
#define R2X_LONG(to,from)  .dw pr2x,to,from,4
#define R2X_WORD(to,from)  .dw pr2x,to,from,2
#define	SET_IP(i,l,a,b,c,d)  .dw i,l,a|(b<<8),i,l+2,c|(d<<8)


#define low(x)      ((x)&0xff)
#define high(x)     low(((x)>>8))
#define BSWAP(v)    ((low(v)<<8)|high(v))

#endif



