
#ifndef NO_USER_TCP
INPUT ( usertcp.o )
#endif

#ifdef USE_BOOTP
INPUT ( bootp_normal.o )
#endif

#ifdef NET_CONFIG_IP
INPUT ( bootp_setip.o )
#endif

#ifdef DEBUGGER
#define SERIAL_DEBUGGER
#endif

#ifndef NO_SERIAL
# ifdef SERIAL_ALWAYS_BINARY
#  define SERIAL_OBJ serial_bin.o
# else
#  ifdef SERIAL_DEBUGGER
#   ifdef SERIAL_FULL_PARITY
#    define SERIAL_OBJ serial_debug_full.o
#   else
#    define SERIAL_OBJ serial_debug.o
#   endif
#  else
#   ifdef SERIAL_FULL_PARITY
#    define SERIAL_OBJ serial_full.o
#   else
#    define SERIAL_OBJ serial_norm.o
#   endif
#  endif
# endif
#endif

INPUT ( kernel.o )
#ifdef SERIAL_OBJ
INPUT ( SERIAL_OBJ )
#endif
GROUP ( kernel.a  picoweb.a )

OUTPUT_FORMAT("elf32-avr","elf32-avr","elf32-avr")
OUTPUT_ARCH(avr:2)
MEMORY
{
  text   (rx)   : ORIGIN = 0,    LENGTH = 8K
  data   (rw!x) : ORIGIN = 0x60, LENGTH = 512
  eeprom (rw!x) : ORIGIN = 0,    LENGTH = 512
  seeprom (rw!x) : ORIGIN = 0x8000,    LENGTH = 64K
  pcode_definitions (rw!x)  : ORIGIN = 0,    LENGTH = 64K
  undefined_section (rw!x)  : ORIGIN = 0,    LENGTH = 0K
  symbol_references (rw!x)  : ORIGIN = 0,    LENGTH = 0K
}
SECTIONS
{
  /* Read-only sections, merged into text segment: */
  .hash          : { *(.hash)		}
  .dynsym        : { *(.dynsym)		}
  .dynstr        : { *(.dynstr)		}
  .gnu.version   : { *(.gnu.version)	}
  .gnu.version_d   : { *(.gnu.version_d)	}
  .gnu.version_r   : { *(.gnu.version_r)	}
  .rel.init      : { *(.rel.init)	}
  .rela.init     : { *(.rela.init)	}
  .rel.text      :
    {
      *(.rel.text)
      *(.rel.text.*)
      *(.rel.gnu.linkonce.t*)
    }
  .rela.text     :
    {
      *(.rela.text)
      *(.rela.text.*)
      *(.rela.gnu.linkonce.t*)
    }
  .rel.fini      : { *(.rel.fini)	}
  .rela.fini     : { *(.rela.fini)	}
  .rel.rodata    :
    {
      *(.rel.rodata)
      *(.rel.rodata.*)
      *(.rel.gnu.linkonce.r*)
    }
  .rela.rodata   :
    {
      *(.rela.rodata)
      *(.rela.rodata.*)
      *(.rela.gnu.linkonce.r*)
    }
  .rel.data      :
    {
      *(.rel.data)
      *(.rel.data.*)
      *(.rel.gnu.linkonce.d*)
    }
  .rela.data     :
    {
      *(.rela.data)
      *(.rela.data.*)
      *(.rela.gnu.linkonce.d*)
    }
  .rel.ctors     : { *(.rel.ctors)	}
  .rela.ctors    : { *(.rela.ctors)	}
  .rel.dtors     : { *(.rel.dtors)	}
  .rela.dtors    : { *(.rela.dtors)	}
  .rel.got       : { *(.rel.got)		}
  .rela.got      : { *(.rela.got)		}
  .rel.bss       : { *(.rel.bss)		}
  .rela.bss      : { *(.rela.bss)		}
  .rel.plt       : { *(.rel.plt)		}
  .rela.plt      : { *(.rela.plt)		}
  /* Internal text space or external memory */
  .text :
  {
    *(vectors)
    *(imports)
    *(reset_start)
    *(reset_io)
    *(reset_pcode)
    *(reset_io_pcode)
    *(load_sram_eeprom)
    *(reset_00)
    *(reset_01)
    *(reset_network)
    *(reset_02)
    *(reset_03)
    *(reset)
    *(reset_end)
    *(fastloop_top)
    *(fast_00)
    *(fast_01)
    *(fast)
    *(fast_02)
    *(fast_03)
    *(fast_slow_transition)
    *(slowloop_top)
    *(slow_00)
    *(slow_01)
    *(slow)
    *(slow_02)
    *(slow_03)
    *(fastloop_continue)
    *(tcp_001)
    *(tcp_conn_check)
    *(tcp_002)
    *(.progmem.gcc*)
    *(.progmem*)
    *(strings)
    . = ALIGN(2);
    *(.text)
    . = ALIGN(2);
    *(.text.*)
    . = ALIGN(2);
    *(.fini)
     _etext = . ; 
  }  > text
  .data	  : AT (ADDR (.text) + SIZEOF (.text))
  {
    *(.data)
    *(.gnu.linkonce.d*)
    . = ALIGN(2);
     _edata = . ; 
  }  > data
  .bss  SIZEOF(.data) + ADDR(.data) :
       AT (ADDR (.text) + SIZEOF (.text) + SIZEOF (.data))
  {
     PROVIDE (__bss_start = .) ; 
    *(.bss)
    *(COMMON)
     PROVIDE (__bss_end = .) ; 
    *(uninitialized_data)
     _end = . ;
  }  > data
  .eeprom  :
  {
    *(eeprom_reserved)
    *(eeprom*)
    *(.eeprom*)
     __eeprom_end = . ; 
  }  > eeprom
  seeprom : AT (8K)  {
    *(seeprom_kludge)
    *(seeprom_strings)
    *(seeprom)
    *(seeprom_cgi_table)
    *(seeprom_cgi)
    *(seeprom_cgi_strings)
    . = ALIGN(2);
    *(seeprom_last)
    *(seeprom_last_strings)
  } >seeprom
  /* Stabs debugging sections.  */
  .stab 0 : { *(.stab) }
  .stabstr 0 : { *(.stabstr) }
  .stab.excl 0 : { *(.stab.excl) }
  .stab.exclstr 0 : { *(.stab.exclstr) }
  .stab.index 0 : { *(.stab.index) }
  .stab.indexstr 0 : { *(.stab.indexstr) }
  .comment 0 : { *(.comment) }
  /* DWARF debug sections.
     Symbols in the DWARF debugging sections are relative to the beginning
     of the section so we begin them at 0.  */
  /* DWARF 1 */
  .debug          0 : { *(.debug) }
  .line           0 : { *(.line) }
  /* GNU DWARF 1 extensions */
  .debug_srcinfo  0 : { *(.debug_srcinfo) }
  .debug_sfnames  0 : { *(.debug_sfnames) }
  /* DWARF 1.1 and DWARF 2 */
  .debug_aranges  0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  /* DWARF 2 */
  .debug_info     0 : { *(.debug_info) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line     0 : { *(.debug_line) }
  .debug_frame    0 : { *(.debug_frame) }
  .debug_str      0 : { *(.debug_str) }
  .debug_loc      0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }
  PROVIDE (__ddf = 0x25f);
  pcode_definitions : {
    *(pcode_definitions)
  } >pcode_definitions
  symbol_references : {
    *(symbol_references)
  } >symbol_references
  undefined_section : {
    *(*)
    . = 0 ;
  } >undefined_section
}
