;+
; **-plisttab-pcode subroutine to list Web file table
;
; pcall plisttab
;
; inputs:
;   none
;
; outputs:
;   list of files printed using "pprint" (CR/LF line termination)
;-
.section seeprom
    .global plisttab
plisttab:
    ppushn buf,6               ; save temps
    pcrlf
    pmovwi buf,pfindfile       ; get base of file table
    pandwi buf,0x7fff          ; mask of SEEPROM bit
plisttab_next:
    pwdr
    pmovwi buf+2,pfindfile_end ; at end?
    pandwi buf+2,0x7fff        ; (must mask out SEEPROM bit)
    pcmpwi buf+2,[buf]
    pjumpeq plisttab_done      ; exit if at end
    psee2s buf+2,[buf],4       ; get address of next string from SEEPROM
    pprint [buf+4]             ; print string
    pcrlf
    paddwi buf,6               ; bump to next string address
    pjump plisttab_next        ; back for more
plisttab_done:
    ppopn buf,6                ; restore temps
    pret
