;
;  pchk_port_url_parms - check URL for "?X=Y" and set PORTD bit
;
;    "X" is PORTD bit number and Y is value (0 or 1)
;
#define OFFSET buf
#define VAL    buf+2

.section seeprom

    .global pchk_port_url_parms
pchk_port_url_parms:
    ppushn OFFSET,4              ; save temps
    purl2s OFFSET,[url_parms],2  ; check first parameter
    pjumpne no_port_url_parms    ; exit of none
    pcmpbi OFFSET+1,'='          ; "n="?
    pjumpne no_port_url_parms

    pcmpbi OFFSET,'0'            ; check character
    pjumplo no_port_url_parms    ; exit if < '0'
    pcmpbi OFFSET,'9'+1          ; check character
    pjumphis no_port_url_parms   ; exit if > '9'

    paddwi url_parms,2
    purl2s VAL,[url_parms],1     ; get X of "n=X"
    pjumpne no_port_url_parms    ; exit of none

    ;;;;pandwi OFFSET,0x0f       ; convert char to value
    ;;;;pandwi pchkfile_str,0x0f ; convert char to value
    ;;;pprintb "val=",VAL,1
    ;;;pprintb " bit=",OFFSET,1
    ;;;pcrlf
    ;;;ptestport 0x04
    ;;;pjumpne xxxxx
    ;;;pprint "ptestport 0x04 equal\r\n"
  ;;;xxxxx:

    psetportdbit [byte VAL],[byte OFFSET]  ; set port bit

no_port_url_parms:
    ppopn OFFSET,4                 ; restore temps
    pret

;+ 
; **-testport-set flags according to PORTD bit state
;    
; pcall testport
;
; inputs:
;   psetparm_parm = bit number (low 3 bits)
;
; outputs: 
;   Z flag: set of bit = 0
;           cleared of bit = 1
;-
    .global testport
testport:
    ptestport                      ; test I/O port bit
    pret

;+
; **-psetportdbit-set bit in PORTD
;
; psetportdbit value,bit
;
; inputs:
;   r10l = value (bit 0 only)
;   r12l = bit number (low 3 bits)
;
; outputs:
;   PORTD bit set to value
;-
.cseg
    .global psetportdbit
psetportdbit:   pcode_routine 2
    mov r20,r10                 ; value
    mov r21,r12                 ; bit number
    rcall exp2_r21              ; r22 = 1<<r21
    in r0,portd
    com r22
    and r0,r22                  ; clear bit
    andi r20,1                  ; 0/1
    breq psetportdbit_out
    com r22                     ; back to just the bit
    or r0,r22
psetportdbit_out:
    out portd,r0
    ret

#if 0
;+ 
; **-ptestport-set flags according to PORTD bit state
;    
; ptestport bit
;
; inputs:
;   r10l = bit number (low 3 bits)
;
; outputs: 
;   Z flag: set of bit = 0
;           cleared of bit = 1
;-
.cseg
    .global ptestport
ptestport:  pcode_routine 1
    mov r21,r10                      ; command parameter
#else
;+ 
; **-ptestport-set flags according to PORTD bit state
;    
; ptestport
;
; inputs:
;   psetparm_parm = bit number (low 3 bits)
;
; outputs: 
;   Z flag: set of bit = 0
;           cleared of bit = 1
;-
.cseg
    .global ptestport
ptestport:  pcode_routine 0
    lds r21,psetparm_parm           ; get LSB of global parameter
#endif
    rcall exp2_r21                  ; r22 = 1<<r21
    in i0,portd
    and i0,r22
    rcall set_pcode_flags
    ret

;+
; **-exp2_r21-compute 1<<r21.
;
; inputs:
;   r21 = power of 2 desired (0-7)
;
; outputs:
;   r22 = value
;-
.cseg
    .global exp2_r21
exp2_r21:
    ldi r22,1                   ; will be our bit mask
    andi r21,7                  ; bit 0..7
exp2_loop:
    breq expret
    lsl r22
    dec r21
    rjmp exp2_loop
expret:
    ret

